## libtexttools 2.0.3

=== Makefile ===
# TEXTTOOLS - tests makefile

all:
	make -C C_code
	make -C examples

clean:
	make -C C_code clean
	make -C examples clean
	rm *.o
	rm *.ali

=== C_code/Makefile ===
# TEXTTOOLS - tests makefile

all: curses.o system.o

curses.o: curses.c
	cc -O -c curses.c

system.o: system.c
	cc -O -c system.c

clean:
	rm -f *.o

=== cpp/Makefile ===

all: common_test adafiles
	c++ -c t.cc
	gnatbind -n ../cpp
	gnatgcc -c b~cpp.adb
	gnatlink -o t t.o ../C_code/*.o ../cpp.ali -lncurses -lm --link=c++

common_test: common_test.cpp
	c++ -c common_test.cpp
	gnatbind -n ../cpp
	gnatgcc -c b~cpp.adb
	gnatlink -o common_test common_test.o ../C_code/*.o ../cpp.ali -lncurses -lm --link=c++

adafiles:
	gnatmake -c -i -O1 -gnataon -I.. cpp.ads

=== examples/Makefile ===
# TEXTTOOLS - tests makefile

# GCC Options
#
# GCC Options for Gnat 3.x
#GCC_OPTIONS=-O1 -m486 -malign-loops=2 -malign-jumps=2 -malign-functions=2 -fno-strength-reduce
# GCC Options for Gnat 5.x
GCC_OPTIONS=-O1 -fno-strength-reduce

all: basic basic2 alert listinfo listinfo2 scrollable uio_demo uio2_demo os_demo

basic: basic.adb
	gnatmake -c -i ${GCC_OPTIONS} -gnataon -I.. -fstack-check basic.adb
	gnatbind -I.. -x basic.ali
	gnatlink basic.ali ../C_code/*.o -lm -lncurses
basic2: basic2.adb
	gnatmake -c -i ${GCC_OPTIONS} -gnataon -I.. -fstack-check basic2.adb
	gnatbind -I.. -x basic2.ali
	gnatlink basic2.ali ../C_code/*.o -lm -lncurses
alert: alert.adb
	gnatmake -c -i ${GCC_OPTIONS} -gnataon -I.. -fstack-check alert.adb
	gnatbind -I.. -x alert.ali
	gnatlink alert.ali ../C_code/*.o -lm -lncurses
listinfo: listinfo.adb
	gnatmake -c -i ${GCC_OPTIONS} -gnataon -I.. -fstack-check listinfo.adb
	gnatbind -I.. -x listinfo.ali
	gnatlink listinfo.ali ../C_code/*.o -lm -lncurses
listinfo2: listinfo2.adb
	gnatmake -c -i ${GCC_OPTIONS} -gnataon -I.. -fstack-check listinfo2.adb
	gnatbind -I.. -x listinfo2.ali
	gnatlink listinfo2.ali ../C_code/*.o -lm -lncurses
scrollable: scrollable.adb
	gnatmake -c -i ${GCC_OPTIONS} -gnataon -I.. -fstack-check scrollable.adb
	gnatbind -I.. -x scrollable.ali
	gnatlink scrollable.ali ../C_code/*.o -lm -lncurses
uio_demo: uio_demo.adb
	gnatmake -c -i ${GCC_OPTIONS} -gnataon -I.. -fstack-check uio_demo.adb
	gnatbind -I.. -x uio_demo.ali
	gnatlink uio_demo.ali ../C_code/*.o -lm -lncurses
uio2_demo: uio2_demo.adb
	gnatmake -c -i ${GCC_OPTIONS} -gnataon -I.. -fstack-check uio2_demo.adb
	gnatbind -I.. -x uio2_demo.ali
	gnatlink uio2_demo.ali ../C_code/*.o -lm -lncurses
os_demo: os_demo.adb
	gnatmake -c -i ${GCC_OPTIONS} -gnataon -I.. -fstack-check os_demo.adb
	gnatbind -I.. -x os_demo.ali
	gnatlink os_demo.ali ../C_code/*.o -lm -lncurses

clean:
	rm -f *.o
	rm -f *.ali
	rm -f basic basic2

## libtexttools 2.0.5

=== Makefile ===
# TEXTTOOLS - tests makefile

all:
	make -C C_code
	make -C examples
	ar q libtexttools.a *.o C_code/*.o

clean:
	make -C C_code clean
	make -C examples clean
	rm -f *.o
	rm -f *.ali
	rm -f libtexttools.a

install: all
	install --mode=444 libtexttools.a /usr/local/lib/libtexttools.a

=== examples/Makefile ===
--- 
+++ 
@@ -49,5 +49,5 @@
 clean:
 	rm -f *.o
 	rm -f *.ali
-	rm -f basic basic2
+	rm -f basic basic2 alert listinfo listinfo2 scrollable uio_demo uio2_demo os_demo

## libtexttools 2.0.6

=== Makefile ===
#!/usr/bin/make -f

##############
# Legal stuff
##############

# Build script for Texttools.
# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2009 Nicolas Boulenguez <nicolas.boulenguez@free.fr>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA

export LIB_NAME := texttools
SOVERSION := 1
export SONAME := lib$(LIB_NAME).so.$(SOVERSION)
export LIB_DIR := .

# Ignore "make" obsolete suffix rules
.SUFFIXES:

# gnatmake can do parallel builds; we don't want make to interfere.
.NOTPARALLEL:
CPUS := $(shell getconf _NPROCESSORS_ONLN)

.PHONY: examples build clean install

examples:
	$(MAKE) -C examples $@

build: $(SONAME) lib$(LIB_NAME).a
$(SONAME):
	gnatmake -j$(CPUS) --create-missing-dirs -Pbuild.gpr \
          -XLIB_KIND=dynamic -XLIB_OBJ_DIR=shared-obj -XLIB_ALI_DIR=shared-ali
lib$(LIB_NAME).a:
	gnatmake -j$(CPUS) --create-missing-dirs -Pbuild.gpr \
          -XLIB_KIND=static -XLIB_OBJ_DIR=static-obj -XLIB_ALI_DIR=static-ali

clean:
	$(RM) -r shared-obj shared-ali static-obj static-ali
	$(RM) $(SONAME) lib$(LIB_NAME).so lib$(LIB_NAME).a
	$(RM) *~
	$(MAKE) -C examples $@

install: build
	install -d $(DESTDIR)/usr/share/ada/adainclude/$(LIB_NAME)
	install --mode=444 *.ad[sb] C_code/*.[ch] $(DESTDIR)/usr/share/ada/adainclude/$(LIB_NAME)
	install --mode=444 $(LIB_NAME).gpr $(DESTDIR)/usr/share/ada/adainclude
	install -d $(DESTDIR)/usr/lib/ada/adalib/$(LIB_NAME)
	install --mode=444 shared-ali/* $(DESTDIR)/usr/lib/ada/adalib/$(LIB_NAME)
	install --mode=444 lib$(LIB_NAME).a lib$(LIB_NAME).so $(SONAME) $(DESTDIR)/usr/lib

######################################################################
#  All that C stuff will be unnecessary with gprbuild’s mixed C/Ada
#  project files.  For the moment, gnatmake will embed all .o files,
#  we only have to compile them and store them in the object dir.
#####################################################################

C_OBJECTS := $(patsubst C_code/%.c,%.o,$(wildcard C_code/*.c))

$(SONAME): $(addprefix shared-obj/,$(C_OBJECTS))
lib$(LIB_NAME).a: $(addprefix static-obj/,$(C_OBJECTS))

%.o: CFLAGS += -g -O2 -Wall -D_Bool=char -I C_code
# -fstack-check temporarily disabled due to http://gcc.gnu.org/PR20548.
shared-obj/%.o: C_code/%.c | shared-obj
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@ -fPIC
static-obj/%.o: C_code/%.c | static-obj
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@
shared-obj static-obj:
	mkdir --parents $@

=== examples/Makefile ===
#!/usr/bin/make -f

##############
# Legal stuff
##############

# Build script for Texttools examples.
# Copyright (c) 2009 Nicolas Boulenguez <nicolas.boulenguez@free.fr>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA

#####################

# do no use parallel builds; we want explicit logs.
# neither Make
.NOTPARALLEL:
# neither gnatmake
CPUS := 1


EXAMPLES := $(patsubst %.adb,%,$(wildcard *.adb))
C_OBJECTS := $(patsubst ../C_code/%.c,%.o,$(wildcard ../C_code/*.c))

.PHONY: examples clean

examples: $(EXAMPLES)

.PHONY: $(EXAMPLES)
# phony so that gnatmake will choose wether rebuild
$(EXAMPLES): $(C_OBJECTS)
	gnatmake -j$(CPUS) $@ \
          -cargs -I.. -g -O0 -gnatafno -gnatVa -gnatwa -gnata \
          -largs -lm -lncurses $(C_OBJECTS)

%.o: ../C_code/%.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -g -O0 -Wall -D_Bool=char -I ../C_code $< -o $@
# -fstack-check temporarily disabled due to http://gcc.gnu.org/PR20548.

clean:
	$(RM) *.o *.ali b~*.ad[sb] *~ $(EXAMPLES)

=== debian/changelog ===
libtexttools (2.0.6-2) unstable; urgency=low

  [Ludovic Brenta]
  * debian/control (DM-Upload-Allowed): yes.
    (*-dev): depend on gnat, ada-compiler.
    (*-dbg, *-doc): suggest gnat, gnat-4.4, ada-compiler.

  [Nicolas Boulenguez]
  * control: (Architectures) any like all Ada packages
    (see http://lists.debian.org/debian-ada/2010/02/msg00002.html)

 -- Ludovic Brenta <lbrenta@debian.org>  Sun, 20 Jun 2010 21:02:14 +0200

libtexttools (2.0.6-1) unstable; urgency=low

  * new upstream release.
    Causes package name changes, see 2.0.5-2.
    libtexttools1-dev -> libtexttools2-dev (with Conflicts and Replaces)
    libtexttools3(-dbg) -> libtexttools4(-dbg)
    Closes: #557894, #249917, #563991.
  * control: updated XS-Vcs- field to Vcs- to follow new dpkg policy.
    (Architectures) documented alpha removal
      Added armel (Closes: #568446).
    (Priority) extra seems more realistic
    (Vcs-Browser) used official URL.
    (Section) removed binary section inherited from source
    (Description) given each binary a distinct description
    (Standards-Version) Updated to 3.8.4.0, no changes needed.
  * build.gpr;rules: documented -fstack-check removal
  * watch: added.
  * copyright: GPL-3 instead of GPL.
  * rules:
    Generated separated debhelper files: more readability, less overloadings.
    Used upstream build process, with a patch to transmit soversion.
  * Switch to dpkg-source 3.0 (quilt) format

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Wed, 10 Feb 2010 00:54:33 +0100

libtexttools (2.0.5-2) unstable; urgency=low

  [Nicolas Boulenguez]
  * Package name changes (see extensive discussion at
    http://people.debian.org/~lbrenta/debian-ada-policy.html):
    libtexttools-dev -> libtexttools1-dev (with Conflicts and Replaces)
    libtexttools2.0.5 -> libtexttools3
  * control: conforms to standards version 3.8.3 and debhelper 7,
    added homepage and source section, added -dev and -dbg packages,
    changed aliversion and soversion because of gnat-4.4 transition
  * rules: uses debhelper facilities and a project file
  * compat: added.
  * patches: instead of ../patches.
  * libtexttools-dev: removed obsolete postinst script
  * build.gpr: added debian build project file
  * Closes: 477474 (RFA) new maintainer
  * Closes: 405466 not reproducible with gnat-4.4
  * Closes: 542419 added kfreebsd-amd64 to the architectures list

  [Ludovic Brenta]
  * debian/build.gpr: disable -fstack-check.
    Eric Botcazou says: "-fstack-check is broken with GCC 4.4 on x86/x86-64
    Linux, it generates code that will easily segfault"
    (http://gcc.gnu.org/PR20548).
  * debian/control: add Conflicts and Replaces where necessary.
    (Architecture): remove alpha due to http://gcc.gnu.org/PR42073.
    (XS-VCS-Browser): use the official URL.
  * debian/rules (CFLAGS): use char, not int, to represent Booleans; in Ada,
    Boolean is an 8-bit type.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Sat, 21 Nov 2009 15:07:47 +0100

libtexttools (2.0.5-1) unstable; urgency=low
  
  [Ludovic Brenta]
  * New upstream version.
  * Migrate to GCC 4.3; bump soversion to 2.0.5 due to new ABI.
  * patches/stdbool.patch: new; move from the .diff.gz to a separate patch.
  * Build-depend on quilt; apply the above patch in debian/rules.
  * texttools.gpr: change into a library project file (new feature of GCC 4.3).
  
  [Thiemo Seufer]
  * Add support for mips and mipsel.  Closes: #475572.
  * Build-depend on gnat and gnat-4.3.

 -- Ludovic Brenta <lbrenta@debian.org>  Sat, 19 Apr 2008 14:50:30 +0200

libtexttools (2.0.3-4) unstable; urgency=medium

  * Acknowledge NMU, but revert most of it.
  * debian/changelog: restore the local variables.  They will become obsolete
    only after I stop using them.
  * debian/control (Build-Depends): depend on gnat >= 4.1.
    (Maintainer): change to my Debian email address.
    (Uploaders): remove.
    (Architecture): add alpha, amd64, hppa, ia64, and s390.
    (Standards-Version): update to 3.7.2 with no changes required.
    (libtexttools2): rename to libtexttools2.0 due to new ABI.  Conflict with
    and Replace the previous version.  Closes: #378824.
    (libtexttools-dev): depend on gnat-4.1, libtexttools2.0.
  * deban/rules: use different compiler flags for C and Ada, per the NMU.
    Do not do recursive calls anymore.  Do not delete object files anymore;
    place PIC and non-PIC objects in different directories.
    (binary-arch): split into one pre target, one target per package, and
    one post (common) target.
  * debian/texttools.gpr: update.

 -- Ludovic Brenta <lbrenta@debian.org>  Fri, 22 Sep 2006 17:59:43 +0200
	

libtexttools (2.0.3-3.1) unstable; urgency=high

  * Non-maintainer upload.
  * Rebuild with gnat-4.1. (Closes: #377721)
    * Remove build-dependency on gnat (<< 3.16).
    * Set CFLAGS to "-O2 -g".
  * Remove obsolete local variables from the bottom of the changelog.

 -- Steinar H. Gunderson <sesse@debian.org>  Tue, 18 Jul 2006 11:54:12 +0200

libtexttools (2.0.3-3) unstable; urgency=low
  
  * debian/rules: Accept any character in the Debian upload number.
    Closes: #359902.

 -- Ludovic Brenta <ludovic@ludovic-brenta.org>  Sat,  1 Apr 2006 13:56:03 +0200
  

libtexttools (2.0.3-2) unstable; urgency=low
  
  * debian/control: Add support for GNU/kFreeBSD.  Build-depend on gnat
    (>=3.15p-19).  Update Standards-Version from 3.6.1 to 3.6.2 with no
    changes.  Change maintainer's email address.

 -- Ludovic Brenta <ludovic@ludovic-brenta.org>  Thu,  2 Mar 2006 08:01:20 +0100
	

libtexttools (2.0.3-1) unstable; urgency=low

  * Initial Release.  Closes: #236548.

 -- Ludovic Brenta <ludovic.brenta@insalien.org>  Tue, 23 Mar 2004 08:05:13 +0100

Local variables:
left-margin: 2
End:

=== debian/control ===
Source: libtexttools
Section: libdevel
Priority: extra
Maintainer: Nicolas Boulenguez <nicolas.boulenguez@free.fr>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7.0.50~), ncurses-dev, gnat, gnat-4.4
Standards-Version: 3.8.4.0
Vcs-Browser: http://ada-france.org:8081/branch/changes/org.debian.texttools
Homepage: http://www.pegasoft.ca/tt.html

Package: libtexttools2-dev
Architecture: any
# alpha is temporarily disabled due to #http://gcc.gnu.org/PR42073
Depends: ${misc:Depends}, gnat, gnat-4.4, ada-compiler, libtexttools4 (= ${binary:Version})
Conflicts: libtexttools-dev, libtexttools1-dev
Replaces: libtexttools-dev, libtexttools1-dev
Description: Ada and C++ library for writing console applications: development
 The Texttools packages are a GPL, ncurses-based library for the Linux
 console.  Texttools contain more than 600 procedures and functions to
 create windows, draw scroll bars, handle the mouse and keyboard
 events, play sounds, and much more.  The Texttools package also
 provides a thick binding to Linux kernel calls.  You can create a wide
 variety of application programs using Texttools alone.
 .
 Install this package if you want to write Ada or C++ programs that
 use Texttools.

Package: libtexttools4
Section: libs
Architecture: any
# alpha is temporarily disabled due to #http://gcc.gnu.org/PR42073
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ada and C++ library for writing console applications: shared library
 The Texttools packages are a GPL, ncurses-based library for the Linux
 console.  Texttools contain more than 600 procedures and functions to
 create windows, draw scroll bars, handle the mouse and keyboard
 events, play sounds, and much more.  The Texttools package also
 provides a thick binding to Linux kernel calls.  You can create a wide
 variety of application programs using Texttools alone.
 .
 This package contains the runtime shared library.

Package: libtexttools-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Conflicts: libtexttools-dev (<< 2.0.6-1)
Suggests: gnat, gnat-4.4, ada-compiler
Description: Ada and C++ library for writing console applications: documentation
 The Texttools packages are a GPL, ncurses-based library for the Linux
 console.  Texttools contain more than 600 procedures and functions to
 create windows, draw scroll bars, handle the mouse and keyboard
 events, play sounds, and much more.  The Texttools package also
 provides a thick binding to Linux kernel calls.  You can create a wide
 variety of application programs using Texttools alone.
 .
 This package contains the documentation.

Package: libtexttools4-dbg
Section: debug
Architecture: any
# alpha is temporarily disabled due to #http://gcc.gnu.org/PR42073
Depends: ${misc:Depends}, libtexttools4 (= ${binary:Version})
Recommends: libtexttools2-dev (= ${binary:Version})
Suggests: gnat, gnat-4.4, ada-compiler
Description: Ada and C++ library for writing console applications: debug symbols
 The Texttools packages are a GPL, ncurses-based library for the Linux
 console.  Texttools contain more than 600 procedures and functions to
 create windows, draw scroll bars, handle the mouse and keyboard
 events, play sounds, and much more.  The Texttools package also
 provides a thick binding to Linux kernel calls.  You can create a wide
 variety of application programs using Texttools alone.
 .
 This package contains the runtime debug symbols.

=== debian/rules ===
#!/usr/bin/make -f

##############
# Legal stuff
##############

# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2009-2010 Nicolas Boulenguez <nicolas.boulenguez@free.fr>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

##########################################
# Guess some variables from control file.
##########################################
# LIB_NAME and SOVERSION must be exported to upstream Makefile.

export LIB_NAME := $(shell sed -n -e "s/^Source: lib\(.\+\)$$/\1/p" debian/control)
ifndef LIB_NAME
  $(error Could not guess LIB_NAME from debian/control)
endif

export SOVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\(.\+\)-dbg$$/\1/p" debian/control)
ifndef SOVERSION
  $(error Could not guess SOVERSION from debian/control)
endif

ALIVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\(.\+\)-dev$$/\1/p" debian/control)
ifndef ALIVERSION
  $(error Could not guess ALIVERSION from debian/control)
endif

SONAME := lib$(LIB_NAME).so.$(SOVERSION)
LIB_PKG := lib$(LIB_NAME)$(SOVERSION)
DBG_PKG := lib$(LIB_NAME)$(SOVERSION)-dbg
DEV_PKG := lib$(LIB_NAME)$(ALIVERSION)-dev
DOC_PKG := lib$(LIB_NAME)-doc

############################
# Ada Library Debian Helper
############################
# This a trick to use debhelper automation with external files,
# even if their names must match the package version.

# Each file named debian/ALDH.oldname is preprocessed and renamed
# according to these macros, before any build or install.  The
# preprocessed file is removed before any clean.
ALDH_macros := LIB_NAME ALIVERSION SOVERSION SONAME LIB_PKG DBG_PKG DEV_PKG DOC_PKG

ALDH_sed := sed $(foreach macro,$(ALDH_macros),-e s/$(macro)/$($(macro))/g)

define ALDH_template
ALDH_targets += $(2)
$(2): $(1)
	$(ALDH_sed) $(1) > $(2)
endef # ALDH_template

ALDH_targets :=
$(foreach template,$(wildcard debian/ALDH.*),\
  $(eval $(call ALDH_template,\
    $(template),\
    $(shell echo $(template) | $(ALDH_sed) -e s/ALDH.//))))

build binary binary-arch binary-indep install: $(ALDH_targets)

clean: ALDH_clean
.PHONY: ALDH_clean
ALDH_clean:
	rm -f $(ALDH_targets)

######################
# debhelper overrides
######################

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

.PHONY: build binary binary-arch binary-indep clean install
build binary binary-arch binary-indep clean install:
	dh $@

override_dh_compress:
	dh_compress --all --exclude=.ads --exclude=.adb --exclude=Makefile --exclude=.c --exclude=.h --exclude=.cpp

override_dh_strip:
	dh_strip --package=$(LIB_PKG) --dbg-package=$(DBG_PKG)
	dh_strip --remaining-packages

override_dh_installdocs:
	dh_installdocs --all --link-doc=$(LIB_PKG)

## libtexttools 2.0.7

=== Makefile ===
--- 
+++ 
@@ -48,9 +48,16 @@
 	gnatmake -j$(CPUS) --create-missing-dirs -Pbuild.gpr \
           -XLIB_KIND=static -XLIB_OBJ_DIR=static-obj -XLIB_ALI_DIR=static-ali
 
+#system.o:
+#	cd C_code
+#	$(CC) -O -c system.c
+#	$(CC) -O -c curses.c
+#	cd ..
+
 clean:
 	$(RM) -r shared-obj shared-ali static-obj static-ali
 	$(RM) $(SONAME) lib$(LIB_NAME).so lib$(LIB_NAME).a
+	$(RM) C_code/*.o *.o *.ali
 	$(RM) *~
 	$(MAKE) -C examples $@

=== debian/changelog ===
libtexttools (2.0.7-2) unstable; urgency=low

  * rules: do not strip static library archive.
    added run-tests target
  * ALDH.DOC_PKG: remove duplicate file from docs.
  * README.Debian: should not depend on the architecture.
  * control: removed dependencies on virtual package ada-compiler.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Fri, 17 Feb 2012 20:18:57 +0100

libtexttools (2.0.7-1) unstable; urgency=low

  * New upstream release (Closes: #642588).
  * Build with gnat-4.6 (Closes: #642648)
  * Multi-arch support.
  * Upgrade to debhelper 8.9.8, policy 3.9.2, dpkg-dev 1.16.1
    (dpkg-dev now defaults to source/local-options and simplifies debian/rules)
    (arch/indep selective debhelper overrides)
  * Use gprbuild instead of upstream Makefile.
  * control: Breaks is enough between -doc and out-of-date -dev.
    -dev package renaming, Conflicts & Replaces due to debian-ada-policy.
    (Vcs-*): Added Vcs-Browser, corrected Vcs-Mtn
    (Build-Depends): unversioned libncurses-dev
  * patches/*: DEP-3 conformant headers
    Call Ada cos/sin instead of C ones to avoid a dependency.
  * copyright: DEP-5 conformant

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Sat, 01 Oct 2011 00:26:09 +0200

=== debian/control ===
Source: libtexttools
Section: libdevel
Priority: extra
Maintainer: Nicolas Boulenguez <nicolas.boulenguez@free.fr>
DM-Upload-Allowed: yes
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 8.9.8),
 gnat, gnat-4.6, gprbuild,
 libncurses-dev
Standards-Version: 3.9.2
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libtexttools
Vcs-Mtn: www.ada-france.org org.debian.libtexttools
Homepage: http://www.pegasoft.ca/tt.html

Package: libtexttools3-dev
Architecture: any
Depends: ${misc:Depends},
  gnat, gnat-4.6,
  libtexttools5 (= ${binary:Version})
Description: Ada and C++ library for writing console applications: development
 The Texttools packages are a GPL, ncurses-based library for the Linux
 console.  Texttools contain more than 600 procedures and functions to
 create windows, draw scroll bars, handle the mouse and keyboard
 events, play sounds, and much more.  The Texttools package also
 provides a thick binding to Linux kernel calls.  You can create a wide
 variety of application programs using Texttools alone.
 .
 Install this package if you want to write Ada or C++ programs that
 use Texttools.

Package: libtexttools5
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ada and C++ library for writing console applications: shared library
 The Texttools packages are a GPL, ncurses-based library for the Linux
 console.  Texttools contain more than 600 procedures and functions to
 create windows, draw scroll bars, handle the mouse and keyboard
 events, play sounds, and much more.  The Texttools package also
 provides a thick binding to Linux kernel calls.  You can create a wide
 variety of application programs using Texttools alone.
 .
 This package contains the runtime shared library.

Package: libtexttools-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libtexttools5 (= ${binary:Version})
Recommends: libtexttools3-dev (= ${binary:Version})
Suggests: gnat,
Description: Ada and C++ library for writing console applications: debug symbols
 The Texttools packages are a GPL, ncurses-based library for the Linux
 console.  Texttools contain more than 600 procedures and functions to
 create windows, draw scroll bars, handle the mouse and keyboard
 events, play sounds, and much more.  The Texttools package also
 provides a thick binding to Linux kernel calls.  You can create a wide
 variety of application programs using Texttools alone.
 .
 This package contains the runtime debug symbols.

Package: libtexttools-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Breaks: libtexttools-dev (<< 2.0.6-1)
Suggests: gnat,
Description: Ada and C++ library for writing console applications: documentation
 The Texttools packages are a GPL, ncurses-based library for the Linux
 console.  Texttools contain more than 600 procedures and functions to
 create windows, draw scroll bars, handle the mouse and keyboard
 events, play sounds, and much more.  The Texttools package also
 provides a thick binding to Linux kernel calls.  You can create a wide
 variety of application programs using Texttools alone.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

##############
# Legal stuff
##############

# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2009-2011 Nicolas Boulenguez <nicolas.boulenguez@free.fr>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

######################
# Set some variables #
######################

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))

SOVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\([[:digit:]]\+\)$$/\1/p" debian/control)
ifndef SOVERSION
  $(error Could not guess SOVERSION from debian/control)
endif

ALIVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\([[:digit:]]\+\)-dev$$/\1/p" debian/control)
ifndef ALIVERSION
  $(error Could not guess ALIVERSION from debian/control)
endif

SONAME := lib$(LIB_NAME).so.$(SOVERSION)
LIB_PKG := lib$(LIB_NAME)$(SOVERSION)
DBG_PKG := lib$(LIB_NAME)-dbg
DEV_PKG := lib$(LIB_NAME)$(ALIVERSION)-dev
DOC_PKG := lib$(LIB_NAME)-doc

# -R: avoid setting run path option (aka rpath)
# -j: number of jobs
GPRBUILD_FLAGS := -R -j$(shell getconf _NPROCESSORS_ONLN)

############################
# Ada Library Debian Helper
############################
# This a trick to use debhelper automation with external files,
# even if their names must match the package version.

# Each file named debian/ALDH.oldname is preprocessed and renamed
# according to these macros, before any build or install.  The
# preprocessed file is removed before any clean.
ALDH_macros := \
  ALIVERSION \
  DBG_PKG \
  DEB_HOST_MULTIARCH \
  DEV_PKG \
  DOC_PKG \
  LIB_NAME \
  LIB_PKG \
  SONAME \
  SOVERSION

ALDH_sed := sed $(foreach macro,$(ALDH_macros),-e s/$(macro)/$($(macro))/g)

define ALDH_template
ALDH_targets += $(2)
$(2): $(1)
	$(ALDH_sed) $(1) > $(2)
endef # ALDH_template

ALDH_targets :=
$(foreach template,$(wildcard debian/ALDH.*),\
  $(eval $(call ALDH_template,\
    $(template),\
    $(shell echo $(template) | $(ALDH_sed) -e s/ALDH.//))))

build build-arch build-indep binary binary-arch binary-indep install: $(ALDH_targets)

clean: ALDH_clean
.PHONY: ALDH_clean
ALDH_clean:
	rm -f $(ALDH_targets)

######################
# debhelper overrides
######################

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_clean:
	$(RM) -r shared-* static-*

override_dh_auto_build-indep:
override_dh_auto_build-arch:
	gprbuild $(GPRBUILD_FLAGS) --create-missing-dirs build.gpr \
          -XLIB_NAME=$(LIB_NAME) \
          -XSONAME=$(SONAME) \
          -XLIB_KIND=static \
          -XLIB_DIR=static-lib \
          -XLIB_OBJ_DIR=static-obj \
          -XLIB_ALI_DIR=static-ali
	gprbuild $(GPRBUILD_FLAGS) --create-missing-dirs build.gpr \
          -XLIB_NAME=$(LIB_NAME) \
          -XSONAME=$(SONAME) \
          -XLIB_KIND=dynamic \
          -XLIB_DIR=shared-lib \
          -XLIB_OBJ_DIR=shared-obj \
          -XLIB_ALI_DIR=shared-ali

override_dh_auto_install:

override_dh_installdocs:
	dh_installdocs --link-doc=$(LIB_PKG) \
          --package=$(LIB_PKG) \
          --package=$(DEV_PKG) \
          --package=$(DBG_PKG)
	dh_installdocs --remaining-packages

override_dh_compress:
	dh_compress --package=$(DEV_PKG) \
          --exclude=.ads \
          --exclude=.adb \
          --exclude=Makefile \
          --exclude=.c \
          --exclude=.h
	dh_compress --package=$(DOC_PKG) \
          --exclude=.ads \
          --exclude=.adb \
          --exclude=Makefile \
          --exclude=.c \
          --exclude=.h \
          --exclude=.cpp
	dh_compress --remaining-packages

override_dh_strip:
	dh_strip --package=$(LIB_PKG) --dbg-package=$(DBG_PKG)
	dh_strip --package=$(DEV_PKG) --exclude=lib$(LIB_NAME).a
	dh_strip --remaining-packages

######################################################################

RUN_TESTS_TMP := libtexttools-run-tests-XXXXXXXXXX

run-tests:
	TMPDIR=$$(mktemp --tmpdir --directory $(RUN_TESTS_TMP)) && \
        export TMPDIR && \
        (cd $$TMPDIR && sh $(CURDIR)/debian/tests/link_with_shared); \
        if test $$? = 0; then echo ok; else echo ko; fi; \
        rm -f -r $$TMPDIR

## libtexttools 2.1.0

=== Makefile ===
# Build script for Texttools.
# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2009-2012 Nicolas Boulenguez <nicolas.boulenguez@free.fr>

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

########################
# Global configuration #
########################

LIB_NAME := texttools

SOVERSION := 1

################################
# Build and test configuration #
################################

# Use environment variables if available, this is common practice for
# CPPFLAGS, CFLAGS and LDFLAGS.
CFLAGS   ?= -O2
ADAFLAGS ?= -O2

.NOTPARALLEL:
GNATMAKE_OPTIONS := -j$(shell getconf _NPROCESSORS_ONLN)

ifdef ALL_CHECKS
  CFLAGS += -Wall -Wextra -Wformat -Wformat-security -g
  ADAFLAGS += -Wall -Wextra -g -gnatE -gnatQ -gnatVa -gnata -gnatf	\
  -gnato -gnatq -gnatySdx -gnaty0 -gnatyM159 -gnatw.e -gnatwH
  GNATMAKE_OPTIONS += -s -we
endif

# We want the same compiler for C and Ada sources.
CC := gnatgcc

LDLIBS := $(shell ncurses5-config --libs)

##############################
# Installation configuration #
##############################

# Each of the following path should be prefixed with
DESTDIR :=

# The sources files are installed into a LIB_NAME subdirectory of
SRC_DIR := usr/share/ada/adainclude

# A LIB_NAME.gpr project convenient for library usage is installed into
GPR_DIR := usr/share/ada/adainclude
# The content of this file ignores DESTDIR.

# The GNAT ALI files are installed into a LIB_NAME subdirectory of
ALI_DIR := usr/lib/ada/adalib

# The static and dynamic library are installed into
LIB_DIR := usr/lib

#########
# Rules #
#########

build: build-dynamic build-static

build-dynamic build-static: build-%: $(LIB_NAME).gpr
	gnatmake -P$< $(GNATMAKE_OPTIONS) -XKIND=$*
clean::
	rm -f $(foreach dir,obj lib,$(foreach kind,dynamic static,build-$(dir)-$(kind)/*))

clean::
	find -name "*~" -delete

test: examples/examples.gpr build-static
	gnatmake -P$< $(GNATMAKE_OPTIONS) -XKIND=static
# Texttools.gpr is found in the current directory when executing this
# recipe, and will be found in the default system location after
# installation.

clean:: examples/examples.gpr texttools.gpr
	gnatclean -P$< -XKIND=static
	rm -f $^
# We need to create them for gnatclean, then suppress it as the last action.

install: build
	install --directory $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	install --mode=644 src/*.ad[sb] src/*.[ch] $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	install --directory $(DESTDIR)/$(GPR_DIR)
	sed template_for_installed_project \
          $(foreach var,LIB_NAME SRC_DIR ALI_DIR LDLIBS LIB_DIR, \
          -e 's/$$($(var))/$(subst $(space),"$(comma) ",$($(var)))/g') \
          > $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
	chmod 644 $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
	install --directory $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	install --mode=444 build-lib-dynamic/*.ali $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	install --directory $(DESTDIR)/$(LIB_DIR)
	install --mode=644 build-lib-static/lib$(LIB_NAME).a $(DESTDIR)/$(LIB_DIR)
	install --mode=644 build-lib-dynamic/lib$(LIB_NAME).so.$(SOVERSION) $(DESTDIR)/$(LIB_DIR)
	cd $(DESTDIR)/$(LIB_DIR) && ln --force --symbolic lib$(LIB_NAME).so.$(SOVERSION) lib$(LIB_NAME).so

uninstall:
	rm -rf $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	rm -f $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
	rm -rf $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).a
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so.$(SOVERSION)
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so

############################################################
#  All that C stuff will be unnecessary with gprbuild’s mixed C/Ada
#  project files.  For the moment, gnatmake will embed all .o files,
#  we only have to compile them and store them in the object dir.

C_SRC := $(wildcard src/*.c)

C_OBJ_DYNAMIC := $(patsubst src/%.c,build-obj-dynamic/%.o,$(C_SRC))
build-dynamic: $(C_OBJ_DYNAMIC)
$(C_OBJ_DYNAMIC): build-obj-dynamic/%.o: src/%.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@ -fPIC

C_OBJ_STATIC  := $(patsubst src/%.c,build-obj-static/%.o, $(C_SRC))
build-static: $(C_OBJ_STATIC)
$(C_OBJ_STATIC): build-obj-static/%.o: src/%.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@

C_OBJ_TEST    := $(patsubst src/%.c,examples/%.o,  $(C_SRC))
test: $(C_OBJ_TEST)
$(C_OBJ_TEST): CFLAGS += -g -Wall -Wextra
$(C_OBJ_TEST): examples/%.o: src/%.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@
clean::
	rm -f $(C_OBJ_TEST)

# gnatmake 4.4 does not handle External_As_List, so we emulate it with
# a template instead of passing the options with -X.
comma := ,
empty :=
space := $(empty) $(empty)
texttools.gpr examples/examples.gpr: %.gpr: %.gpr.sed
	sed $< \
	 $(foreach var,ADAFLAGS CFLAGS LDFLAGS LDLIBS SOVERSION, \
	   -e 's/$(var)/$(subst $(space),"$(comma) ",$($(var)))/') \
	 > $@

.PHONY: build build-dynamic build-static clean install test uninstall

=== debian/changelog ===
libtexttools (2.1.0-8) unstable; urgency=medium

  * allow-slash-in-cflags.diff with a distinct sed separator. Closes: #834248.
  * remove-pack-pragma-when-c-convention.diff thanks to GCC-6 new warning.
  * watch: version 4.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 16 Aug 2016 09:44:01 +0200

libtexttools (2.1.0-7) unstable; urgency=medium

  * Rebuild with gnat-6. Rename lib and -dev packages per Ada policy.
  * Use gprbuild for projects, as gnatmake does not support them anymore.
  * Enable all hardening flags but PIE.
  * No need to Break: libtexttools-dev, not in oldstable anymore.
  * Switch from manual -dbg packages to automatic -dbgsym.
  * copyright: replace duplicate license with separate paragraph.
  * Standards-Version: 3.9.8 (no changes).
  * XS-Testsuite: autopkgtest now obsolete.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 28 Apr 2016 00:40:28 +0200

libtexttools (2.1.0-6) unstable; urgency=medium

  * copyright: sources GPL2-+, all others GPL3-+.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 08 May 2014 09:59:55 +0200

libtexttools (2.1.0-5) unstable; urgency=medium

  * Build with gnat-4.9. Library and -dev packages renamed due to Ada policy.
  * rules: run-tests target obsoleted by sadt from devscripts.
    get-orig-source target not needed with a valid watch file.
  * sources/options: let dpkg select default compressor.
  * Standards-Version: 3.9.5 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 04 May 2014 16:54:20 +0200

libtexttools (2.1.0-4) unstable; urgency=low

  * preinst: typo in directory name. Closes: #721781.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 04 Sep 2013 17:37:22 +0200

libtexttools (2.1.0-3) unstable; urgency=low

  * control: Maintainer, DM-Upload-Allowed: debian address.
     XS-Testsuite: autopkgtest (Closes: #692682)
  * copyright: update
  * tests: updated. Valid test names may not contain underscores.
  * Remove all /usr/share/doc symlinks, preinst scripts.
  * Remove work-around for #680292, bug in gnat-4.6 is closed.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 26 Aug 2013 21:45:04 +0200

libtexttools (2.1.0-2) unstable; urgency=low

  * libtexttools-doc.preinst: remove /usr/share/doc symbolic link when
    upgrading from versions < 2.0.7-1, allowing dpkg to install a
    directory instead (Closes: #690132).

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Fri, 12 Oct 2012 18:23:50 +0200

libtexttools (2.1.0-1) unstable; urgency=low

  * New upstream release.
  * Upstream switched back to gnatmake, so
    control (Depends): dh-ada-library (>= 3) with explicit gprconfig dependency.
  * rules: remove --as-needed from LDFLAGS. gnatmake calls gcc -shared
    LDFLAGS -lgnat in this order, making gcc ignoring some symbols.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Fri, 08 Jun 2012 23:43:32 +0200

libtexttools (2.0.7-3) unstable; urgency=low

  * Switched ALDH mess to dh_ada_library.
    Added debian/texttools.gpr.
  * Created build directories once and for all.
  * Replaced README.Debian with a short reference to Debian Ada Policy.
  * copyright: update.
  * patches: linker_options.patch not needed anymore
  * rules: added get-orig-source.
  * source.lintian-overrides: a generated dependency is passed via substvars
    and not seen by lintian.
  * Standards-Version 3.9.3, debhelper 9 (no changes)
  * control: -dep Depends: on libncurses-dev.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Thu, 05 Apr 2012 02:21:21 +0200

=== debian/control ===
Source: libtexttools
Section: libdevel
Priority: extra
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
 gnat, gnat-6,
 gprbuild (>= 2015-2),
# 2015-2 is compatible with gnat-6
 dh-ada-library (>= 6.7),
# 6.7 knows that -dbg packages are obsolete
 libncurses-dev
Standards-Version: 3.9.8
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libtexttools
Vcs-Mtn: www.ada-france.org org.debian.libtexttools
Homepage: http://www.pegasoft.ca/tt.html

Package: libtexttools5-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends},
 libncurses-dev
Description: Ada library for writing console applications: development
 The Texttools packages are a GPL, ncurses-based library for the Linux
 console.  Texttools contain more than 600 procedures and functions to
 create windows, draw scroll bars, handle the mouse and keyboard
 events, play sounds, and much more.  The Texttools package also
 provides a thick binding to Linux kernel calls.  You can create a wide
 variety of application programs using Texttools alone.
 .
 Install this package if you want to write Ada programs that use
 Texttools.

Package: libtexttools7
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ada library for writing console applications: shared library
 The Texttools packages are a GPL, ncurses-based library for the Linux
 console.  Texttools contain more than 600 procedures and functions to
 create windows, draw scroll bars, handle the mouse and keyboard
 events, play sounds, and much more.  The Texttools package also
 provides a thick binding to Linux kernel calls.  You can create a wide
 variety of application programs using Texttools alone.
 .
 This package contains the runtime shared library.

Package: libtexttools-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: gnat
Description: Ada library for writing console applications: documentation
 The Texttools packages are a GPL, ncurses-based library for the Linux
 console.  Texttools contain more than 600 procedures and functions to
 create windows, draw scroll bars, handle the mouse and keyboard
 events, play sounds, and much more.  The Texttools package also
 provides a thick binding to Linux kernel calls.  You can create a wide
 variety of application programs using Texttools alone.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2009-2016 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging*.mk

DEB_DATE := $(shell dpkg-parsechangelog -S date)

ADAFLAGS += -gnatn

SOVERSION := $(shell sed -n -e "s/^Package: $(DEB_SOURCE)\([[:digit:]]\+\)$$/\1/p" debian/control)
ifndef SOVERSION
  $(warning Could not guess SOVERSION from debian/control)
  # Not error. Policy defines targets that may be run from outside build dir.
endif

POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
  build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@ --with ada-library

# All these targets are redefined or empty. No implicit default behaviour.
.PHONY: $(addprefix override_dh_auto_, \
  configure build-arch build-indep test-arch test-indep install clean)

OPTS += $(foreach var, \
          ADAFLAGS CC CFLAGS CPPFLAGS LDFLAGS SOVERSION,$(var)="$($(var))") \
          GNATMAKE_OPTIONS="$(BUILDER_OPTIONS)"
override_dh_auto_clean:
	dh_auto_clean -- $(OPTS)
	rm -f default.cgpr
default.cgpr:
	gprconfig --batch --config=Ada --config=C,,,,gnatgcc
override_dh_auto_build-arch: default.cgpr
 # Ensure deterministic timestamps in ALI files.
	find . -depth -name "*.ad[bs]" -a -newermt '$(DEB_DATE)' -print0 | \
	  xargs -0r touch --no-dereference --date='$(DEB_DATE)'
	dh_auto_build -a -- $(OPTS)
override_dh_auto_test-arch:
	dh_auto_test -a -- $(OPTS)

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --all $(addprefix --exclude=,.ads .adb .c .h)

=== debian/watch ===
version=4
http://www.pegasoft.ca/tt-down.html \
downloads/texttools@ANY_VERSION@\.tgz
